import javax.swing.*;
import java.awt.event.*;
import java.beans.*; // Property change stuff

public class Message extends JDialog {

    private JOptionPane optionPane;

    public Message(JFrame sender, String message) {
	super(sender, true);
	setTitle("Mapper message");

	Object[] text = {
	    message,
	};

	final String btnOk = "OK";
	Object[] options = {btnOk};

	optionPane = new JOptionPane(text, 
				     JOptionPane.INFORMATION_MESSAGE,
				     JOptionPane.OK_OPTION,
				     null,
				     options,
				     options[0]);
	setContentPane(optionPane);
	setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);

	// This makes the close operation to be sent to the optionPane
	addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent we) {
		    optionPane.setValue(new Integer(JOptionPane.CLOSED_OPTION));
		}
	    });

	optionPane.addPropertyChangeListener(new PropertyChangeListener() {
		public void propertyChange(PropertyChangeEvent e) {
		    String property = e.getPropertyName();

		    if (isVisible() &&
			(property.equals(JOptionPane.VALUE_PROPERTY) ||
			 property.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
			Object value = optionPane.getValue();
			
			if (value == JOptionPane.UNINITIALIZED_VALUE) {
			    //ignore reset
			    return;
			}
			
			optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);
			
			if (value.equals(btnOk)) {
			    // Do something and... disappear
			    setVisible(false);
			} else {
			    // User clicked cancel or closed the window
			    setVisible(false);
			}
		    }
		}
	    });
	
	pack();
    }
    
}
